//////////////////////////////////////////////////////////////////////////////
// Filename:          /home/gwj/spartan3a/interrupt/drivers/intgen_v1_00_a/src/intgen.c
// Version:           1.00.a
// Description:       intgen Driver Source File
// Date:              Sat Jun 13 13:21:13 2009 (by Create and Import Peripheral Wizard)
//////////////////////////////////////////////////////////////////////////////


/***************************** Include Files *******************************/

#include "intgen.h"

/************************** Function Definitions ***************************/

/**
 *
 * Enable all possible interrupts from INTGEN device.
 *
 * @param   baseaddr_p is the base address of the INTGEN device.
 *
 * @return  None.
 *
 * @note    None.
 *
 */
void INTGEN_EnableInterrupt(void * baseaddr_p)
{
  Xuint32 baseaddr;
  baseaddr = (Xuint32) baseaddr_p;

  /*
   * Enable all interrupt source from user logic.
   */
  INTGEN_mWriteReg(baseaddr, INTGEN_INTR_IPIER_OFFSET, 0x00000001);

  /*
   * Enable all possible interrupt sources from device.
   */
  INTGEN_mWriteReg(baseaddr, INTGEN_INTR_DIER_OFFSET,
    INTR_TERR_MASK
    | INTR_DPTO_MASK
    | INTR_IPIR_MASK
    );

  /*
   * Set global interrupt enable.
   */
  INTGEN_mWriteReg(baseaddr, INTGEN_INTR_DGIER_OFFSET, INTR_GIE_MASK);
}

/**
 *
 * Example interrupt controller handler for INTGEN device.
 * This is to show example of how to toggle write back ISR to clear interrupts.
 *
 * @param   baseaddr_p is the base address of the INTGEN device.
 *
 * @return  None.
 *
 * @note    None.
 *
 */
void INTGEN_Intr_DefaultHandler(void * baseaddr_p)
{
  Xuint32 baseaddr;
  Xuint32 IntrStatus;
Xuint32 IpStatus;
  baseaddr = (Xuint32) baseaddr_p;

  /*
   * Get status from Device Interrupt Status Register.
   */
  IntrStatus = INTGEN_mReadReg(baseaddr, INTGEN_INTR_DISR_OFFSET);

  xil_printf("Device Interrupt! DISR value : 0x%08x \n\r", IntrStatus);

  /*
   * Verify the source of the interrupt is the user logic and clear the interrupt
   * source by toggle write baca to the IP ISR register.
   */
  if ( (IntrStatus & INTR_IPIR_MASK) == INTR_IPIR_MASK )
  {
    xil_printf("User logic interrupt! \n\r");
    IpStatus = INTGEN_mReadReg(baseaddr, INTGEN_INTR_IPISR_OFFSET);
    INTGEN_mWriteReg(baseaddr, INTGEN_INTR_IPISR_OFFSET, IpStatus);
  }

}

